% 
%   MLCV Winter 2015
%   Homework Assignment 01 - Probabilistic Reasoning and Learning
%
%   Exercise 1d) Bayes filter
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sensor_sigma = 0.3;
motion_sigma = 0.1;
velocity = 1;

states = 0:5;
times  = 1:3;

measurements = [1.2 1.6 2.5];

bel = zeros(1, length(states));
bel(1) = 1;
% Store all beliefs
BEL = zeros(length(times)+1, length(states));
BEL(1,:) = bel;

%% Bayes filter algorithm
for ti=1:length(times)
    
    if ti == 1, 
        delta_t = times(ti); 
    else
        delta_t = times(ti) - times(ti-1);
    end
    fprintf('\n\nTime step %d\n\n', ti);
    
    % Motion update
    fprintf('Action update u_%d\n\n', ti);
    for xi=1:length(states)
        x = states(xi);
        fprintf('\nAccumulating MOTION beliefs from all states to state %.2f\n', x);
        for xi_old=1:length(states)
            x_old = states(xi_old);
            p_move = normpdf(x, x_old + velocity*delta_t, motion_sigma);
            fprintf('p(x_%d=%.2f | x_%d=%.2f, u_%d) = %f  =>  ', ti, x, ti-1, x_old, ti, p_move);
            bel(xi) = bel(xi) + p_move * BEL(ti, xi_old);
            fprintf('bel(x_%d = %.2f) = %f\n', ti, x, bel(xi));           
        end
    end

    % Sensor update
    fprintf('\n\nSensor update z_%d\n\n', ti);
    for xi=1:length(states)
        x = states(xi);
        p_sense = normpdf(measurements(ti), x, sensor_sigma);
        fprintf('p(z_%d | x_%d = %.2f) = %f  =>  ', ti , ti, x, p_sense);
        bel(xi) = p_sense * bel(xi);
        fprintf('bel(x_%d = %.2f) = %f\n', ti, x, bel(xi));  
    end
        
    % Normalize
    bel = bel / sum(bel);
    fprintf('\nEta is %f, normalization:\n\n', sum(bel));
    for xi=1:length(states)
        x = states(xi);
        fprintf('bel(x_%d = %.2f) = %f\n', ti, x, bel(xi));  
    end    
    BEL(ti+1,:) = bel;
end


