% 
%   MLCV Winter 2015
%   Homework Assignment 01 - Probabilistic Reasoning and Learning
%
%   Exercise 2) Regression
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Create sample trajectory
t = 0:1:5;
x = 2*cos(t);
y = 2*sin(t);
z = sin(t)+cos(t)+t;
D = [x' y' z'];

%% Plot lines between points
%subplot(1,2,1);
plot3(x,y,z); %,'*r');
hold on
plot3(x(1), y(1), z(1), '*r');

%% Animation
% for i=1:length(x)
%   plot3(x(i),y(i),z(i),'*r');
%   hold on;
%   pause(0.01);
% end


%% Assume constant velocity
Phi = [ones(length(t),1) t'];

%% Assume constant acceleration
Phi = [ones(length(t),1) t' (t.^2)'];


%% Compute pseudo-inverse of Phi
Phi_pi = inv(Phi'*Phi)*Phi';

% Compute weights
wx = Phi_pi*x';
wy = Phi_pi*y';
wz = Phi_pi*z';

W = Phi_pi*[x' y' z'];

v = W(2,:);
v_magnitude = norm(v);

% Compute residual errors
rx = norm(Phi*wx - x');
ry = norm(Phi*wy - y');
rz = norm(Phi*wz - z');

Residuals = [rx ry rz]


%% Next most likely position
p = 6;
phi_new = [1 p p^2];
t_new = phi_new*[wx wy wz];


